# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without repolib

%global namedversion %{version}

Name:           animal-sniffer
Version:        1.6
Release:        8.2%{?dist}
Epoch:          0
Summary:        Tools to assist verifying backward compatibility of Java classes
Group:          Development/Tools
License:        MIT
URL:            http://mojo.codehaus.org/animal-sniffer/
Source0:        http://repo1.maven.org/maven2/org/codehaus/mojo/animal-sniffer-parent/1.6/animal-sniffer-parent-1.6-source-release.zip
Source1:        animal-sniffer.sh
Patch0:         0001-add-asm-dependency-to-maven-plugin.patch
Patch1:         animal-sniffer-pom-version.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       maven2
%if 0
# FIXME: What? These two aren't in the BR
Requires:       objectweb-asm
Requires:       ant
# FIXME: circular dependency
Requires:       mojo-signatures
%endif
Requires:       java
BuildRequires:  java-devel
BuildRequires:  maven2
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-invoker
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-shade
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven2-plugin-plugin
BuildRequires:  cobertura-maven-plugin
BuildRequires:  build-helper-maven-plugin
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-compiler
BuildRequires:  plexus-containers-component-javadoc
BuildRequires:  mojo-parent
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Tools to assist verifying that classes compiled with a newer JDK/API
are compatible with an older JDK/API.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n animal-sniffer-parent-%{version}
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1

%build
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
%{_bindir}/mvn-jpp -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} deploy javadoc:aggregate

%install
rm -rf %{buildroot}

install -d -m 755 %{buildroot}%{_bindir}
install -pm 755 %{SOURCE1} %{buildroot}%{_bindir}/%{name}

pushd maven2-brew
#./org/codehaus/mojo/animal-sniffer-parent/1.6/animal-sniffer-parent-1.6-site.xml

# jars
%{__mkdir_p} %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/codehaus/mojo/animal-sniffer/%{namedversion}/animal-sniffer-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/codehaus/mojo/animal-sniffer-annotations/%{namedversion}/animal-sniffer-annotations-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/codehaus/mojo/animal-sniffer-ant-tasks/%{namedversion}/animal-sniffer-ant-tasks-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/codehaus/mojo/animal-sniffer-enforcer-rule/%{namedversion}/animal-sniffer-enforcer-rule-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/codehaus/mojo/animal-sniffer-maven-plugin/%{namedversion}/animal-sniffer-maven-plugin-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/codehaus/mojo/java-boot-classpath-detector/%{namedversion}/java-boot-classpath-detector-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p org/codehaus/mojo/animal-sniffer/%{namedversion}/animal-sniffer-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer.pom
%{__cp} -p org/codehaus/mojo/animal-sniffer-annotations/%{namedversion}/animal-sniffer-annotations-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer-annotations.pom
%{__cp} -p org/codehaus/mojo/animal-sniffer-ant-tasks/%{namedversion}/animal-sniffer-ant-tasks-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer-ant-tasks.pom
%{__cp} -p org/codehaus/mojo/animal-sniffer-enforcer-rule/%{namedversion}/animal-sniffer-enforcer-rule-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer-enforcer-rule.pom
%{__cp} -p org/codehaus/mojo/animal-sniffer-maven-plugin/%{namedversion}/animal-sniffer-maven-plugin-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer-maven-plugin.pom
%{__cp} -p org/codehaus/mojo/animal-sniffer-parent/%{namedversion}/animal-sniffer-parent-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer-parent.pom
%{__cp} -p org/codehaus/mojo/java-boot-classpath-detector/%{namedversion}/java-boot-classpath-detector-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-java-boot-classpath-detector.pom

# depmaps
%add_to_maven_depmap org.codehaus.mojo animal-sniffer %{namedversion} JPP/%{name} animal-sniffer
%add_to_maven_depmap org.codehaus.mojo animal-sniffer-annotations %{namedversion} JPP/%{name} animal-sniffer-annotations
%add_to_maven_depmap org.codehaus.mojo animal-sniffer-ant-tasks %{namedversion} JPP/%{name} animal-sniffer-ant-tasks
%add_to_maven_depmap org.codehaus.mojo animal-sniffer-enforcer-rule %{namedversion} JPP/%{name} animal-sniffer-enforcer-rule
%add_to_maven_depmap org.codehaus.mojo animal-sniffer-maven-plugin %{namedversion} JPP/%{name} animal-sniffer-maven-plugin
%add_to_maven_depmap org.codehaus.mojo animal-sniffer-parent %{namedversion} JPP/%{name} animal-sniffer-parent
%add_to_maven_depmap org.codehaus.mojo java-boot-classpath-detector %{namedversion} JPP/%{name} java-boot-classpath-detector
popd

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%endif

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%attr(0755,root,root) %{_bindir}/%{name}
%dir %{_javadir}*/%{name}
%exclude %dir %{_javadocdir}/%{name}
%{_javadir}*/%{name}/animal-sniffer-%{namedversion}.jar
%{_javadir}*/%{name}/animal-sniffer.jar
%{_javadir}*/%{name}/animal-sniffer-annotations-%{namedversion}.jar
%{_javadir}*/%{name}/animal-sniffer-annotations.jar
%{_javadir}*/%{name}/animal-sniffer-ant-tasks-%{namedversion}.jar
%{_javadir}*/%{name}/animal-sniffer-ant-tasks.jar
%{_javadir}*/%{name}/animal-sniffer-enforcer-rule-%{namedversion}.jar
%{_javadir}*/%{name}/animal-sniffer-enforcer-rule.jar
%{_javadir}*/%{name}/animal-sniffer-maven-plugin-%{namedversion}.jar
%{_javadir}*/%{name}/animal-sniffer-maven-plugin.jar
%{_javadir}*/%{name}/java-boot-classpath-detector-%{namedversion}.jar
%{_javadir}*/%{name}/java-boot-classpath-detector.jar
%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer.pom
%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer-annotations.pom
%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer-ant-tasks.pom
%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer-enforcer-rule.pom
%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer-maven-plugin.pom
%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer-parent.pom
%{_datadir}/maven2/poms/JPP.%{name}-java-boot-classpath-detector.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Aug 15 2011 David Walluck <dwalluck@redhat.com> 0:1.6-8.2
- patch some pom versions

* Fri Jun 24 2011 David Walluck <dwalluck@redhat.com> 0:1.6-8.1
- release (based on Fedora release 8)
